from django.conf import settings


def get_db():
    if settings.DB_BACKEND == "DRUID":
        from core.db.druid import DruidBackend

        return DruidBackend()
    elif settings.DB_BACKEND == "ELASTICSEARCH":
        from core.db.elastic import ElasticsearchBackend

        return ElasticsearchBackend()
    elif settings.DB_BACKEND == "MANTICORE":
        from core.db.manticore import ManticoreBackend

        return ManticoreBackend()
    else:
        raise Exception("Invalid DB backend")


db = get_db()
