def construct_query(index, net, channel, src, num, size, type=None, nicks=None):
    # Get the initial query
    extra_must = []
    extra_should = []
    extra_should2 = []
    if num:
        extra_must.append({"match_phrase": {"num": num}})
    if net:
        extra_must.append({"match_phrase": {"net": net}})
    if channel:
        extra_must.append({"match": {"channel": channel}})
    if nicks:
        for nick in nicks:
            extra_should2.append({"match": {"nick": nick}})
    types = ["msg", "notice", "action", "kick", "topic", "mode"]
    fields = [
        "nick",
        "ident",
        "host",
        "channel",
        "ts",
        "msg",
        "type",
        "net",
        "src",
        "tokens",
    ]
    if index == "internal":
        fields.append("mtype")
        if channel == "*status" or type == "znc":
            if {"match": {"channel": channel}} in extra_must:
                extra_must.remove({"match": {"channel": channel}})
            extra_should2 = []
            # Type is one of msg or notice
            # extra_should.append({"match": {"mtype": "msg"}})
            # extra_should.append({"match": {"mtype": "notice"}})
            extra_should.append({"match": {"type": "znc"}})
            extra_should.append({"match": {"type": "self"}})

            extra_should2.append({"match": {"type": "znc"}})
            extra_should2.append({"match": {"nick": channel}})
        elif type == "auth":
            if {"match": {"channel": channel}} in extra_must:
                extra_must.remove({"match": {"channel": channel}})
            extra_should2 = []
            extra_should2.append({"match": {"nick": channel}})
            # extra_should2.append({"match": {"mtype": "msg"}})
            # extra_should2.append({"match": {"mtype": "notice"}})

            extra_should.append({"match": {"type": "query"}})
            extra_should2.append({"match": {"type": "self"}})
            extra_should.append({"match": {"nick": channel}})
        else:
            for ctype in types:
                extra_should.append({"match": {"mtype": ctype}})
    else:
        for ctype in types:
            extra_should.append({"match": {"type": ctype}})
    query = {
        "index": index,
        "limit": size,
        "query": {
            "bool": {
                "must": [
                    # {"equals": {"src": src}},
                    # {
                    #     "bool": {
                    #         "should": [*extra_should],
                    #     }
                    # },
                    # {
                    #     "bool": {
                    #         "should": [*extra_should2],
                    #     }
                    # },
                    *extra_must,
                ]
            }
        },
        "fields": fields,
        # "_source": False,
    }
    if extra_should:
        query["query"]["bool"]["must"].append({"bool": {"should": [*extra_should]}})
    if extra_should2:
        query["query"]["bool"]["must"].append({"bool": {"should": [*extra_should2]}})
    return query
