import orjson
from django import template

register = template.Library()


@register.filter
def pretty(data):
    prettified = orjson.dumps(data, option=orjson.OPT_INDENT_2).decode("utf-8")
    if prettified.startswith("{"):
        prettified = prettified[1:]
    if prettified.endswith("}"):
        prettified = prettified[:-1]

    return prettified
